/*
**************************************
*  LPC1769                           *
*  Author: JM_PALOMINO               *
*  Title: Example keypad 4x4         *
*                                    *
**************************************
*/

#ifdef __USE_CMSIS
#include "LPC17xx.h"
#include "lpc17xx_gpio.h"
#include "lpc17xx_pinsel.h"
#include "lpc17xx_timer.h"
#include "Input_Output.h"
#include "lcd_2x16.h"
#endif

#include <cr_section_macros.h>
#include <NXP/crp.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


/* Variable to store CRP value in. Will be placed automatically
   by the linker when "Enable Code Read Protect" selected.
   See crp.h header for more information*/
__CRP const unsigned int CRP_WORD = CRP_NO_CRP ;

char tecla[1];
unsigned char aux=0, i=0;
void Set_Up_Pins(void);


int main (void)
{

      SystemInit(); /* configured to external crystal(12MHZ) and pll to work
	  to 100MHZ(processor) */
      Set_Up_Pins();
      init_lcd();
      lcd_clear();
      Lcd_Out("KEY:",0,6),Timer0_Wait(100,ms);

 while (1) {

  // put you code here
	 for(i=0;i<4;i++) {

		Pin_Write_State(2,0,FALSE);
		Pin_Write_State(2,1,TRUE);
		Pin_Write_State(2,2,TRUE);
		Pin_Write_State(2,3,TRUE);

		Timer0_Wait(10,ms);

/*1*/   if((Pin_Read_State(2,4)==0)&& (i==0)) tecla[0]=1+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*2*/	if((Pin_Read_State(2,5)==0)&& (i==0)) tecla[0]=2+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*3*/	if((Pin_Read_State(2,6)==0)&& (i==0)) tecla[0]=3+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*A*/	if((Pin_Read_State(2,7)==0)&& (i==0)) tecla[0]=65,   Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;

		Pin_Write_State(2,0,TRUE);
		Pin_Write_State(2,1,FALSE);
		Pin_Write_State(2,2,TRUE);
		Pin_Write_State(2,3,TRUE);

		Timer0_Wait(10,ms);

/*4*/   if((Pin_Read_State(2,4)==0)&& (i==1)) tecla[0]=4+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*5*/	if((Pin_Read_State(2,5)==0)&& (i==1)) tecla[0]=5+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*6*/	if((Pin_Read_State(2,6)==0)&& (i==1)) tecla[0]=6+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*B*/	if((Pin_Read_State(2,7)==0)&& (i==1)) tecla[0]=66,   Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;

		Pin_Write_State(2,0,TRUE);
		Pin_Write_State(2,1,TRUE);
		Pin_Write_State(2,2,FALSE);
		Pin_Write_State(2,3,TRUE);

		Timer0_Wait(10,ms);

/*7*/   if((Pin_Read_State(2,4)==0)&& (i==2)) tecla[0]=7+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*8*/	if((Pin_Read_State(2,5)==0)&& (i==2)) tecla[0]=8+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*9*/	if((Pin_Read_State(2,6)==0)&& (i==2)) tecla[0]=9+48, Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*C*/	if((Pin_Read_State(2,7)==0)&& (i==2)) tecla[0]=67,   Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;

		Pin_Write_State(2,0,TRUE);
		Pin_Write_State(2,1,TRUE);
		Pin_Write_State(2,2,TRUE);
		Pin_Write_State(2,3,FALSE);

		Timer0_Wait(10,ms);

/***/	if((Pin_Read_State(2,4)==0)&& (i==3)) tecla[0]=42,  Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*0*/	if((Pin_Read_State(2,5)==0)&& (i==3)) tecla[0]=48,  Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*#*/	if((Pin_Read_State(2,6)==0)&& (i==3)) tecla[0]=35,  Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;
/*D*/	if((Pin_Read_State(2,7)==0)&& (i==3)) tecla[0]=68,  Lcd_Out(tecla,1,aux),Timer0_Wait(80,ms),aux++;

	  }
	 if(aux>15) aux=0;
 }

 return 0 ; }


void Set_Up_Pins(void)
{
	             PINSEL_CFG_Type PINSELCfg;

	             //////////////pins for lcd 2x16//////
				 PINSELCfg.Portnum 	= 	PINSEL_PORT_0;
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;  //RW
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_0;
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_0;
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;  //EN
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_1;
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_0;
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_6;   //RS
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_0;
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_15; //D6
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_0;
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_16;  //D7
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_0;
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_17;  //D5
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_0;
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;   //D4
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_18;
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);
				 /////////////////////////////////////////////

				 //////////////pins for keypad 4x4////////////
				 PINSELCfg.Portnum 	= 	PINSEL_PORT_2;  //COL4
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_7;
				 PINSELCfg.Pinmode = PINSEL_PINMODE_PULLUP;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_2; //COL3
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_6;
				 PINSELCfg.Pinmode = PINSEL_PINMODE_PULLUP;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_2; //COL2
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_5;
				 PINSELCfg.Pinmode = PINSEL_PINMODE_PULLUP;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_2; //COL1
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_4;
				 PINSELCfg.Pinmode = PINSEL_PINMODE_PULLUP;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_2; //ROW4
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_3;
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_2; //ROW3
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_2;
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_2; //ROW2
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_1;
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);

				 PINSELCfg.Portnum 	= 	PINSEL_PORT_2; //ROW1
				 PINSELCfg.Funcnum 	= 	PINSEL_FUNC_0;
				 PINSELCfg.Pinnum 	=	PINSEL_PIN_0;
				 PINSELCfg.OpenDrain  =  PINSEL_PINMODE_NORMAL;
				 PINSEL_ConfigPin(&PINSELCfg);
				 /////////////////////////////////////////////

			     GPIO_SetDir(2,0x0F,1);
			     GPIO_SetDir(2,0xF0,0);
			     GPIO_ClearValue(2,0xFF);

}
